package com.ruoyi.frequency.news.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.page.PageResult;
import com.ruoyi.controller.req.NewsPageReq;
import com.ruoyi.controller.resp.NewsDetailResp;
import com.ruoyi.controller.resp.NewsPageResp;
import com.ruoyi.frequency.news.entity.News;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.frequency.news.model.result.NewsCount;
import com.ruoyi.response.ResponseData;
import com.ruoyi.vo.UserVo;

/**
 * 新闻Service接口
 * 
 * @author liwenlong
 * @date 2024-03-19
 */
public interface NewsService extends IService<News>
{
    /**
     * 查询新闻
     * 
     * @param id 新闻主键
     * @return 新闻
     */
    public News selectNewsById(Long id);

    /**
     * 查询新闻列表
     * 
     * @param news 新闻
     * @return 新闻集合
     */
    public TableDataInfo selectNewsList(News news);

    /**
     * 新增新闻
     * 
     * @param news 新闻
     * @return 结果
     */
    public int insertNews(News news);

    /**
     * 修改新闻
     * 
     * @param news 新闻
     * @return 结果
     */
    public int updateNews(News news);

    /**
     * 批量删除新闻
     * 
     * @param ids 需要删除的新闻主键集合
     * @return 结果
     */
    public int deleteNewsByIds(Long[] ids,Integer delFlag);

    /**
     * 新闻列表
     * @param req
     * @param userVo
     * @return
     */
    ResponseData<PageResult<Page<News>>> newsPage(NewsPageReq req, UserVo userVo);

    /**
     *  新闻详情
     * @param id
     * @param userVo
     * @return
     */
    ResponseData<News> newsDetail(Long id,Integer isAddBrowseNum, UserVo userVo);

    News newsInfo(Long id);

    NewsCount statistics(News news);
}
